package at.ac.uibk.gitsearch.es.model;

import java.util.List;

public class ArtemisExerciseInfo extends ExerciseInfo {

    private Float maxPoints;

    private Float bonusPoints;

    private ExerciseMode mode;

    private Boolean staticCodeAnalysis;

    private Boolean allowOfflineIDE;

    private Boolean allowOnlineEditor;

    private Boolean showTestNamesToStudents;

    private Boolean sequentialTestRuns;

    public ArtemisExerciseInfo() {

    }

    public Float getMaxPoints() {
        return maxPoints;
    }

    public Float getBonusPoints() {
        return bonusPoints;
    }

    public ExerciseMode getMode() {
        return mode;
    }

    public Boolean getStaticCodeAnalysis() {
        return staticCodeAnalysis;
    }

    public Boolean getAllowOfflineIDE() {
        return allowOfflineIDE;
    }

    public Boolean getAllowOnlineEditor() {
        return allowOnlineEditor;
    }

    public Boolean getShowTestNamesToStudents() {
        return showTestNamesToStudents;
    }

    public Boolean getSequentialTestRuns() {
        return sequentialTestRuns;
    }

    public ExerciseInfo getExerciseInfoOnly() {
        ExerciseInfo exerciseInfo = new ExerciseInfo();
        if (this.getAssesses() != null) {
            exerciseInfo.setAssesses(this.getAssesses());
        }
        if (this.getAudience() != null) {
            exerciseInfo.setAudience(this.getAudience());
        }
        if (this.getContributor() != null) {
            exerciseInfo.setContributor(this.getContributor());
        }
        exerciseInfo.setCreator(this.getCreator());
        exerciseInfo.setDescription(this.getDescription());
        if (this.getDifficulty() != null) {
            exerciseInfo.setDifficulty(this.getDifficulty());
        }
        if (this.getEducationalAlignment() != null) {
            exerciseInfo.setEducationalAlignment(this.getEducationalAlignment());
        }
        if (this.getEducationalFramework() != null) {
            exerciseInfo.setEducationalFramework(this.getEducationalFramework());
        }
        if (this.getEducationalLevel() != null) {
            exerciseInfo.setEducationalLevel(this.getEducationalLevel());
        }
        if (this.getEducationalUse() != null) {
            exerciseInfo.setEducationalUse(this.getEducationalUse());
        }
        exerciseInfo.setFormat(this.getFormat());
        exerciseInfo.setIdentifier(this.getIdentifier());
        if (this.getImage() != null) {
            exerciseInfo.setImage(this.getImage());
        }
        if (this.getInteractivityType() != null) {
            exerciseInfo.setInteractivityType(this.getInteractivityType());
        }
        if (this.getIsBasedOn() != null) {
            exerciseInfo.setIsBasedOn(this.getIsBasedOn());
        }
        exerciseInfo.setKeyword(this.getKeyword());
        exerciseInfo.setLanguage(this.getLanguage());
        exerciseInfo.setLearningResourceType(this.getLearningResourceType());
        exerciseInfo.setLicense(this.getLicense());
        exerciseInfo.setMetadataVersion(this.getMetadataVersion());
        if (this.getProgrammingLanguage() != null) {
            exerciseInfo.setProgrammingLanguage(this.getProgrammingLanguage());
        }
        exerciseInfo.setPublisher(this.getPublisher());
        if (this.getRequires() != null) {
            exerciseInfo.setRequires(this.getRequires());
        }
        if (this.getStatus() != null) {
            exerciseInfo.setStatus(this.getStatus());
        }
        if (this.getStructure() != null) {
            exerciseInfo.setStructure(this.getStructure());
        }
        if (this.getSubject() != null) {
            exerciseInfo.setSubject(this.getSubject());
        }
        if (this.getTeaches() != null) {
            exerciseInfo.setTeaches(this.getTeaches());
        }
        if (this.getTimeRequired() != null) {
            exerciseInfo.setTimeRequired(this.getTimeRequired());
        }
        exerciseInfo.setTitle(this.getTitle());
        if (this.getTypicalAgeRange() != null) {
            exerciseInfo.setTypicalAgeRange(this.getTypicalAgeRange());
        }
        if (this.getVersion() != null) {
            exerciseInfo.setVersion(this.getVersion());
        }
        return exerciseInfo;
    }

    /**
     * Used to merge attributes of ExerciseInfo into an ArtemisExerciseInfo class
     * @param exerciseInfo to merge
     */
    public void appendExerciseInfo(ExerciseInfo exerciseInfo) {
        this.setAssesses(exerciseInfo.getAssesses());
        this.setAudience(exerciseInfo.getAudience());
        this.setContributor(exerciseInfo.getContributor());
        this.setCreator(exerciseInfo.getCreator());
        this.setDescription(exerciseInfo.getDescription());
        this.setDifficulty(exerciseInfo.getDifficulty());
        this.setEducationalAlignment(exerciseInfo.getEducationalAlignment());
        this.setEducationalFramework(exerciseInfo.getEducationalFramework());
        this.setEducationalLevel(exerciseInfo.getEducationalLevel());
        this.setEducationalUse(exerciseInfo.getEducationalUse());
        this.setFormat(exerciseInfo.getFormat());
        this.setIdentifier(exerciseInfo.getIdentifier());
        this.setImage(exerciseInfo.getImage());
        this.setInteractivityType(exerciseInfo.getInteractivityType());
        this.setIsBasedOn(exerciseInfo.getIsBasedOn());
        this.setKeyword(exerciseInfo.getKeyword());
        this.setLanguage(exerciseInfo.getLanguage());
        this.setLearningResourceType(exerciseInfo.getLearningResourceType());
        this.setLicense(exerciseInfo.getLicense());
        this.setMetadataVersion(exerciseInfo.getMetadataVersion());
        this.setProgrammingLanguage(exerciseInfo.getProgrammingLanguage());
        this.setPublisher(exerciseInfo.getPublisher());
        this.setRequires(exerciseInfo.getRequires());
        this.setStatus(exerciseInfo.getStatus());
        this.setStructure(exerciseInfo.getStructure());
        this.setSubject(exerciseInfo.getSubject());
        this.setTeaches(exerciseInfo.getTeaches());
        this.setTimeRequired(exerciseInfo.getTimeRequired());
        this.setTitle(exerciseInfo.getTitle());
        this.setTypicalAgeRange(exerciseInfo.getTypicalAgeRange());
        this.setVersion(exerciseInfo.getVersion());

//        this.setMetadataVersion(exerciseInfo.getMetadataVersion());
//        this.setType(exerciseInfo.getType());
//        this.setTitle(exerciseInfo.getTitle());
//        this.setLicense(exerciseInfo.getLicense());
//        this.setKeyword(exerciseInfo.getKeyword());
//        this.setFormat(exerciseInfo.getFormat());
//        this.setStructure(exerciseInfo.getStructure());
//        this.setProgrammingLanguage(exerciseInfo.getProgrammingLanguage());
//        this.setLanguage(exerciseInfo.getLanguage());
//        if (exerciseInfo.getCreator() != null) {
//            this.setCreator(List.copyOf(exerciseInfo.getCreator()));
//        }
//        if (exerciseInfo.getContributor() != null) {
//            this.setContributor(List.copyOf(exerciseInfo.getContributor()));
//        }
//        this.setDifficulty(exerciseInfo.getDifficulty());
//        this.setSource(exerciseInfo.getSource());
    }

    public enum ExerciseMode {INDIVIDUAL, TEAM}
}
